package com.kingdee.eas.custom.dormitorysystem.application.app;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.base.log.LogUtil;
import com.kingdee.eas.basedata.person.IPerson;
import com.kingdee.eas.basedata.person.PersonFacadeFactory;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.dormitorysystem.application.CheckInApplicationEntryCollection;
import com.kingdee.eas.custom.dormitorysystem.application.CheckInApplicationEntryInfo;
import com.kingdee.eas.custom.dormitorysystem.application.CheckInApplicationInfo;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsInfo;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.shr.base.syssetting.BasicItemStateEnum;
import com.kingdee.util.DateTimeUtils;
import org.apache.log4j.Logger;

import java.util.Date;

public class CheckInApplicationControllerBean extends AbstractCheckInApplicationControllerBean {
    private static Logger logger = Logger.getLogger(CheckInApplicationControllerBean.class);

    /**
     * ύЧ
     *
     * @param ctx
     * @param model
     * @return
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected IObjectPK _submitEffect(
            Context ctx,
            CoreBaseInfo model
    ) throws BOSException, EASBizException {
        IObjectPK iObjectPK = super._submitEffect(ctx, model);
        CheckInApplicationInfo info = (CheckInApplicationInfo) model;
        //Date date = DateTimeUtils.parseDate("2199-12-31", "yyyy-MM-dd");
        CheckInApplicationEntryCollection entrys = info.getEntrys();
        for (int i = 0; i < entrys.size(); i++) {
            CheckInApplicationEntryInfo entryInfo = entrys.get(i);
            PersonInfo personInfo = entryInfo.getPerson();
            String personId = personInfo.getId().toString();
            //УԱùϵ״̬
            IPerson iPerson = PersonFactory.getLocalInstance(ctx);
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("");
            sic.add("");
            sic.add("");
            sic.add("");
            sic.add("");

            personInfo = iPerson.getPersonInfo(new ObjectUuidPK(personId), sic);
            boolean isInCount = personInfo.getEmployeeType().isIsInCount();
            if (!isInCount) {
                //Աùϵ״̬

                //

            }
            //סԱϢ
            //УʱǷڽ
            //סԱϢ
            OccupantsInfo occupantsInfo = new OccupantsInfo();
            //סԱ
            occupantsInfo.setPerson(personInfo);
            //ס
            occupantsInfo.setCheckInDate(entryInfo.getCheckInDate());
            //
            //occupantsInfo.setCheckOutDate(date);
            //ס
            occupantsInfo.setDormitory(entryInfo.getCheckInRoom());
            //Ա
            //occupantsInfo.setPersonDormitoryType();
            //״̬:
            //occupantsInfo.setState(BasicItemStateEnum.ENABLE);
        }


        return iObjectPK;
    }

    /**
     * 
     *
     * @param ctx
     * @param billId
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _untiCheckBizBill(
            Context ctx,
            String billId
    ) throws BOSException, EASBizException {
        super._untiCheckBizBill(ctx, billId);
    }
}