package com.kingdee.eas.custom.dormitorysystem.occupants.app;

import com.kingdee.eas.custom.dormitorysystem.dormitory.DormitoryInfo;
import com.kingdee.shr.base.syssetting.BasicItemStateEnum;
import org.apache.log4j.Logger;
import javax.ejb.*;
import java.rmi.RemoteException;
import com.kingdee.bos.*;
import com.kingdee.bos.util.BOSObjectType;
import com.kingdee.bos.metadata.IMetaDataPK;
import com.kingdee.bos.metadata.rule.RuleExecutor;
import com.kingdee.bos.metadata.MetaDataPK;
//import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.framework.ejb.AbstractEntityControllerBean;
import com.kingdee.bos.framework.ejb.AbstractBizControllerBean;
//import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.bos.dao.IObjectCollection;
import com.kingdee.bos.service.ServiceContext;
import com.kingdee.bos.service.IServiceContext;

import com.kingdee.eas.framework.app.DataBaseControllerBean;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsCollection;
import com.kingdee.eas.framework.ObjectBaseCollection;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsInfo;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import java.lang.String;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.eas.framework.DataBaseCollection;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;

public class OccupantsControllerBean extends AbstractOccupantsControllerBean
{
    private static Logger logger =
        Logger.getLogger("com.kingdee.eas.custom.dormitorysystem.occupants.app.OccupantsControllerBean");

    @Override
    protected void _save(Context ctx, IObjectPK pk, IObjectValue model) throws BOSException, EASBizException {
        OccupantsInfo occupantsInfo = (OccupantsInfo)model;
        occupantsInfo.setState(BasicItemStateEnum.getEnum(1));
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        Date parse = null;
        try {
            parse = dateFormat.parse("2199-12-31");
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
        occupantsInfo.setCheckOutDate(parse);
        super._save(ctx, pk, occupantsInfo);
    }

    @Override
    protected IObjectPK[] _saveBatchData(Context ctx, IObjectCollection colls) throws BOSException, EASBizException {
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        Date parse = null;
        for (int i = 0; i < colls.size(); i++) {
            OccupantsInfo occupantsInfo = (OccupantsInfo)(colls.getObject(i));
            try {
                parse = dateFormat.parse("2199-12-31");
            } catch (ParseException e) {
                throw new RuntimeException(e);
            }
            occupantsInfo.setCheckOutDate(parse);
            occupantsInfo.setState(BasicItemStateEnum.getEnum(1));
        }
        return super._saveBatchData(ctx, colls);
    }

}